<template>
	<div class="FieldsList">
		<div class="text-center py-6" v-if="isLoading">
			<v-progress-circular :size="50" indeterminate color="primary"></v-progress-circular>
		</div>
		<v-card v-else-if="hasError">
			<v-card-text>There was an error loading resources. Please refresh.</v-card-text>
		</v-card>
		<v-card v-else-if="!hasAccessToFields">
			<v-card-text>You do not have access to any fields yet.</v-card-text>
		</v-card>
		<v-card v-else-if="hasAccessToFields && fieldRows.length === 0">
			<v-card-text
				>No fields match your filters. Try clearing some of your filters to see results, or
				<button @click="clearAllFilters" class="primary--text">clear all filters</button>.</v-card-text
			>
		</v-card>
		<field-list-row v-else v-for="fieldRow in fieldRows" :key="fieldRow.id" :fieldRow="fieldRow"></field-list-row>
	</div>
</template>

<script lang="ts">
import { defineComponent, computed } from '@vue/composition-api';
import { useAllResources } from '@/store/modules/resources';
import { useGroups } from '@/store/modules/group';
import FieldListRow from './FieldListRow.vue';

export default defineComponent({
	components: {
		FieldListRow,
	},
	setup(_, { root }) {
		const {
			isLoaded: areResourcesLoaded,
			isLoading: areResourcesLoading,
			fields,
			hasError: hasResourcesError,
		} = useAllResources(root.$store);
		const { isLoaded: areGroupsLoaded, isLoading: areGroupsLoading, hasError: hasGroupsError } = useGroups(root.$store);
		const isLoading = computed(() => areGroupsLoading.value || areResourcesLoading.value);
		const isLoaded = computed(() => areGroupsLoaded.value && areResourcesLoaded.value);
		const hasError = computed(() => hasGroupsError.value || hasResourcesError.value);
		const fieldRows = computed(() => root.$store.getters['fieldsView/getFieldRows']);
		const hasAccessToFields = computed(() => isLoaded.value && fields.value.length > 0);

		const clearAllFilters = () => root.$store.dispatch('fieldsView/clearAllFilters');

		return {
			isLoaded,
			isLoading,
			hasError,
			hasAccessToFields,
			fieldRows,
			clearAllFilters,
		};
	},
});
</script>

<style lang="scss">
.FieldsList {
	width: 100%;
	height: 100%;
	overflow-y: auto;

	& > .FieldListRow {
		margin-bottom: 8px;
	}

	.v-card:not(.FieldListRow) {
		height: 100%;
	}
}

@media (max-width: 823px) {
	.FieldsList {
		overflow-y: visible;
	}
}
</style>
